Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## edu.emory.mathcs.backport.java.util
Interface NavigableSet

All Superinterfaces:
  java.util.Collection, java.util.Set, java.util.SortedSet

All Known Implementing Classes:
  ConcurrentSkipListSet, TreeSet

public interface NavigableSet
extends java.util.SortedSet

A `SortedSet` extended with navigation methods reporting closest matches for given search targets. Methods , , , and return elements respectively less than, less than or equal, greater than or equal, and greater than a given element, returning if there is no such element. A may be accessed and traversed in either ascending or descending order. The method returns a view of the set with the senses of all relational and directional methods inverted. The performance of ascending operations and views is likely to be faster than that of descending ones. This interface additionally defines methods and that return and remove the lowest and highest element, if one exists, else returning . Methods , , and differ from the like-named methods in accepting additional arguments describing whether lower and upper bounds are inclusive versus exclusive. Subsets of any must implement the interface.

The return values of navigation methods may be ambiguous in implementations that permit elements. However, even in this case the result can be disambiguated by checking . To avoid such issues, implementations of this interface are encouraged to not permit insertion of elements. (Note that sorted sets of `Comparable` elements intrinsically do not permit .)

Methods `subSet(E, E)`, `headSet(E)`, and `tailSet(E)` are specified to return to allow existing implementations of to be compatibly retrofitted to implement , but extensions and implementations of this interface are encouraged to override these methods to return .

This interface is a member of the Java Collections Framework.

Since:
  1.6
Author:
  Doug Lea, Josh Bloch

Method Summary
`java.lang.Object` | `ceiling(java.lang.Object e)` Returns the least element in this set greater than or equal to the given element, or if there is no such element.
`java.util.Iterator` | `descendingIterator()` Returns an iterator over the elements in this set, in descending order.
`NavigableSet` | `descendingSet()` Returns a reverse order view of the elements contained in this set.
`java.lang.Object` | `floor(java.lang.Object e)` Returns the greatest element in this set less than or equal to the given element, or if there is no such element.
`java.util.SortedSet` | `headSet(java.lang.Object toElement)`
`NavigableSet` | `headSet(java.lang.Object toElement, boolean inclusive)` Returns a view of the portion of this set whose elements are less than (or equal to, if is true) .
`java.lang.Object` | `higher(java.lang.Object e)` Returns the least element in this set strictly greater than the given element, or if there is no such element.
`java.util.Iterator` | `iterator()` Returns an iterator over the elements in this set, in ascending order.
`java.lang.Object` | `lower(java.lang.Object e)` Returns the greatest element in this set strictly less than the given element, or if there is no such element.
`java.lang.Object` | `pollFirst()` Retrieves and removes the first (lowest) element, or returns if this set is empty.
`java.lang.Object` | `pollLast()` Retrieves and removes the last (highest) element, or returns if this set is empty.
`NavigableSet` | `subSet(java.lang.Object fromElement, boolean fromInclusive, java.lang.Object toElement, boolean toInclusive)` Returns a view of the portion of this set whose elements range from to .
`java.util.SortedSet` | `subSet(java.lang.Object fromElement, java.lang.Object toElement)`
`java.util.SortedSet` | `tailSet(java.lang.Object fromElement)`
`NavigableSet` | `tailSet(java.lang.Object fromElement, boolean inclusive)` Returns a view of the portion of this set whose elements are greater than (or equal to, if is true) .

Methods inherited from interface java.util.SortedSet
`comparator, first, last`

Methods inherited from interface java.util.Set
`add, addAll, clear, contains, containsAll, equals, hashCode, isEmpty, remove, removeAll, retainAll, size, toArray, toArray`

Method Detail

### lower

    public java.lang.Object lower(java.lang.Object e)

  Returns the greatest element in this set strictly less than the given element, or if there is no such element.

  Parameters:
    `e` - the value to match
  Returns:
    the greatest element less than , or if there is no such element
  Throws:
    `java.lang.ClassCastException` - if the specified element cannot be compared with the elements currently in the set
    `java.lang.NullPointerException` - if the specified element is null and this set does not permit null elements

### floor

    public java.lang.Object floor(java.lang.Object e)

  Returns the greatest element in this set less than or equal to the given element, or if there is no such element.

  Parameters:
    `e` - the value to match
  Returns:
    the greatest element less than or equal to , or if there is no such element
  Throws:
    `java.lang.ClassCastException` - if the specified element cannot be compared with the elements currently in the set
    `java.lang.NullPointerException` - if the specified element is null and this set does not permit null elements

### ceiling

    public java.lang.Object ceiling(java.lang.Object e)

  Returns the least element in this set greater than or equal to the given element, or if there is no such element.

  Parameters:
    `e` - the value to match
  Returns:
    the least element greater than or equal to , or if there is no such element
  Throws:
    `java.lang.ClassCastException` - if the specified element cannot be compared with the elements currently in the set
    `java.lang.NullPointerException` - if the specified element is null and this set does not permit null elements

### higher

    public java.lang.Object higher(java.lang.Object e)

  Returns the least element in this set strictly greater than the given element, or if there is no such element.

  Parameters:
    `e` - the value to match
  Returns:
    the least element greater than , or if there is no such element
  Throws:
    `java.lang.ClassCastException` - if the specified element cannot be compared with the elements currently in the set
    `java.lang.NullPointerException` - if the specified element is null and this set does not permit null elements

### pollFirst

    public java.lang.Object pollFirst()

  Retrieves and removes the first (lowest) element, or returns if this set is empty.

  Returns:
    the first element, or if this set is empty

### pollLast

    public java.lang.Object pollLast()

  Retrieves and removes the last (highest) element, or returns if this set is empty.

  Returns:
    the last element, or if this set is empty

### iterator

    public java.util.Iterator iterator()

  Returns an iterator over the elements in this set, in ascending order.

  Specified by:
    `iterator` in interface `java.util.Set`
  Returns:
    an iterator over the elements in this set, in ascending order

### descendingSet

    public NavigableSet descendingSet()

  Returns a reverse order view of the elements contained in this set. The descending set is backed by this set, so changes to the set are reflected in the descending set, and vice-versa. If either set is modified while an iteration over either set is in progress (except through the iterator's own operation), the results of the iteration are undefined.

  The returned set has an ordering equivalent to ``Collections.reverseOrder`(comparator())`. The expression returns a view of essentially equivalent to .

  Returns:
    a reverse order view of this set

### descendingIterator

    public java.util.Iterator descendingIterator()

  Returns an iterator over the elements in this set, in descending order. Equivalent in effect to .

  Returns:
    an iterator over the elements in this set, in descending order

### subSet

    public NavigableSet subSet(java.lang.Object fromElement,
                               boolean fromInclusive,
                               java.lang.Object toElement,
                               boolean toInclusive)

  Returns a view of the portion of this set whose elements range from to . If and are equal, the returned set is empty unless and are both true. The returned set is backed by this set, so changes in the returned set are reflected in this set, and vice-versa. The returned set supports all optional set operations that this set supports.

  The returned set will throw an on an attempt to insert an element outside its range.

  Parameters:
    `fromElement` - low endpoint of the returned set
    `fromInclusive` - if the low endpoint is to be included in the returned view
    `toElement` - high endpoint of the returned set
    `toInclusive` - if the high endpoint is to be included in the returned view
  Returns:
    a view of the portion of this set whose elements range from , inclusive, to , exclusive
  Throws:
    `java.lang.ClassCastException` - if and cannot be compared to one another using this set's comparator (or, if the set has no comparator, using natural ordering). Implementations may, but are not required to, throw this exception if or cannot be compared to elements currently in the set.
    `java.lang.NullPointerException` - if or is null and this set does not permit null elements
    `java.lang.IllegalArgumentException` - if is greater than ; or if this set itself has a restricted range, and or lies outside the bounds of the range.

### headSet

    public NavigableSet headSet(java.lang.Object toElement,
                                boolean inclusive)

  Returns a view of the portion of this set whose elements are less than (or equal to, if is true) . The returned set is backed by this set, so changes in the returned set are reflected in this set, and vice-versa. The returned set supports all optional set operations that this set supports.

  The returned set will throw an on an attempt to insert an element outside its range.

  Parameters:
    `toElement` - high endpoint of the returned set
    `inclusive` - if the high endpoint is to be included in the returned view
  Returns:
    a view of the portion of this set whose elements are less than (or equal to, if is true)
  Throws:
    `java.lang.ClassCastException` - if is not compatible with this set's comparator (or, if the set has no comparator, if does not implement `Comparable`). Implementations may, but are not required to, throw this exception if cannot be compared to elements currently in the set.
    `java.lang.NullPointerException` - if is null and this set does not permit null elements
    `java.lang.IllegalArgumentException` - if this set itself has a restricted range, and lies outside the bounds of the range

### tailSet

    public NavigableSet tailSet(java.lang.Object fromElement,
                                boolean inclusive)

  Returns a view of the portion of this set whose elements are greater than (or equal to, if is true) . The returned set is backed by this set, so changes in the returned set are reflected in this set, and vice-versa. The returned set supports all optional set operations that this set supports.

  The returned set will throw an on an attempt to insert an element outside its range.

  Parameters:
    `fromElement` - low endpoint of the returned set
    `inclusive` - if the low endpoint is to be included in the returned view
  Returns:
    a view of the portion of this set whose elements are greater than or equal to
  Throws:
    `java.lang.ClassCastException` - if is not compatible with this set's comparator (or, if the set has no comparator, if does not implement `Comparable`). Implementations may, but are not required to, throw this exception if cannot be compared to elements currently in the set.
    `java.lang.NullPointerException` - if is null and this set does not permit null elements
    `java.lang.IllegalArgumentException` - if this set itself has a restricted range, and lies outside the bounds of the range

### subSet

    public java.util.SortedSet subSet(java.lang.Object fromElement,
                                      java.lang.Object toElement)

  Equivalent to .

  Specified by:
    `subSet` in interface `java.util.SortedSet`
  Throws:
    `java.lang.ClassCastException`
    `java.lang.NullPointerException`
    `java.lang.IllegalArgumentException`

### headSet

    public java.util.SortedSet headSet(java.lang.Object toElement)

  Equivalent to .

  Specified by:
    `headSet` in interface `java.util.SortedSet`
  Throws:
    `java.lang.ClassCastException`
    `java.lang.NullPointerException`
    `java.lang.IllegalArgumentException`

### tailSet

    public java.util.SortedSet tailSet(java.lang.Object fromElement)

  Equivalent to .

  Specified by:
    `tailSet` in interface `java.util.SortedSet`
  Throws:
    `java.lang.ClassCastException`
    `java.lang.NullPointerException`
    `java.lang.IllegalArgumentException`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD